#include <qthing>

#include "esp_log.h"
#include "driver/gpio.h"

#include "freertos/FreeRTOS.h"
#include "freertos/task.h"


#include "CyanLight.hpp"


// ### LIBS FOR TESTING ###
#include <cstdlib>
//#include "SpiderLib/SNTP.hpp"
// #include "SpiderLib/Util.hpp"
#include "SiliconTorch/CyanBusCRC.hpp"
#include "SiliconTorch/CyanBus.hpp"
// ###     END LIBS     ###



SiliconTorch::CyanBus::CyanBus* cyanBus = NULL;


qthing::Config cfg;

CyanLight::CyanLightControl* ctrl;

void device_main() {

  // Needed for packet parsing, animation rendering and stuff
  qthing::power_managment_max_power();



  cyanBus = new SiliconTorch::CyanBus::CyanBus(13, 14, 12, 15);  // Pinout of CyanStripe

  // TODO: ???



  qthing::enable_wifi();
  cfg.apply();

  return;

  
  

  ctrl = new CyanLight::CyanLightControl(3);
  //ctrl->addChannel(16);
  //ctrl->addChannel(17);
  
  ctrl->setFrqRes(100, 19);


  for (uint8_t i = 0; i < 100; i++) {

    bool _f = i % 2 == 0;

    ctrl->setPWM(0,  _f      * 1.0f);
    ctrl->setPWM(2, (_f ^ 1) * 1.0f);

    vTaskDelay(50 / portTICK_PERIOD_MS);
  }


  ctrl->setPWM(0, 0.0f);
  ctrl->setPWM(1, 0.0f);
  ctrl->setPWM(2, 1.0f);


  qthing::enable_wifi();
  return;



  auto delay = 10 / portTICK_PERIOD_MS;
  float limit = 50.0f;

  while (true) {
    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, pwm*pwm);
      vTaskDelay(delay);
    }

    for (uint8_t i = 0; i < limit; i++) {
      float pwm = i / limit;
      ctrl->setPWM(0, 1.0f - pwm*pwm);
      vTaskDelay(delay);
    }
  }
}
